/* Parallaxis Version: @(#)makro.h	2.13  2/28/92 14:47:42  */
/* ************************************************************************* */
/*                                                                           */
/* Parallaxis-Compiler von Ingo Barth                                        */
/*                                                                           */
/* Datei : makro.h                                                           */
/*                                                                           */
/* Definitionen und Makros fuer die Erstellung des Syntaxbaumes              */
/*                                                                           */
/* ************************************************************************* */


extern struct T_recdef * silly; /* leere Strukturdefinition */ 
extern int dummy;               /* Variable ohne Bedeutung */

/* Prozedur enthaelt parallele Anweisungen */
# define P_PARAL        1

/* Record mit Varianten */
# define REC_NORM 0
# define REC_CASE 1

/* Parameterart */
# define P_VECTOR       1
# define P_SCALAR       2
# define P_VAR          4

/* Statementart */
# define S_ASSIGN       1
# define S_PROCCALL     2
# define S_IF           3
# define S_CASE         4
# define S_WHILE        5
# define S_REPEAT       6
# define S_LOOP         7
# define S_FOR          8
# define S_WITH         9
# define S_EXIT         10
# define S_RETURN       11
# define S_PARALLEL     12
# define S_PROPAGATE    13
# define S_LOAD         14
# define S_STORE        15
# define S_NICHTS       0

/* Selektionsart */
# define SE_NONE        0
# define SE_SUBRANGE    1
# define SE_ALL         2

/* Designatorart */
# define D_RECORD       1
# define D_ARRAY        2
# define D_DEREF        3

/* Typart */
# define TY_UNDEF       0
# define TY_NAME        1
# define TY_ENUM        2
# define TY_RANGE       3
# define TY_ARRAY       4
# define TY_RECORD      5
# define TY_SET         6
# define TY_POINTER     7

/* Konstantenart */
# define C_NORM         1
# define C_NAME         2
# define C_RECORD       3

/* Art des Ausdrucks */
# define E_BINOP        1
# define E_FUNC         2
# define E_DESIGN       3
# define E_SET          4
# define E_KLEXPR       6
# define E_NOTEXPR      7
# define E_REDUCE       8
# define E_CONST        9
# define E_SINOP        10
# define E_DESIGNAT     11
/* E_DESIGN    nur designator */
/* E_DESIGNAT  expr */

/* binaerer Ausdruck ist gekoppelt ? ( a < b < c ) */
# define EX_EINF        0
# define EX_DOPP        1
# define EX_SPEC        2

/* Deklarationsart bei TYPE und CONST */
# define DEC_CONST      0
# define DEC_TYPE       1

/* Ergebnisart eines Ausdrucks */
# define ERG_UNDEF      0
# define ERG_VAR        1
# define ERG_SPEC       2
/* ERG_VAR   Hilfsvariable */
/* ERG_SPEC  echte Variable (fuer VAR-Parameter) */
# define ERG_CONST      4
/* Konstante */
# define ERG_PROC       5
# define ERG_RAND       6
# define ERG_TYPE       7
# define ERG_REC        8
# define ERG_PORT       9
/* noch keine Zuweisung an Hilfsvariable hat stattgefunden */
