/* Parallaxis Version: @(#)pass2x.h	2.13  2/28/92 14:47:45  */
/* ************************************************************************* */
/*                                                                           */
/* Parallaxis-Compiler von Ingo Barth                                        */
/*                                                                           */
/* Datei : pass2.c                                                           */
/*                                                                           */
/* Funktionen zur semantischen Analyse und Zwischencodeerzeugung             */
/*                                                                           */
/* ************************************************************************* */


#include "defines.h"
# include <math.h>
# undef _REDUCE
# include <errno.h>
# include <signal.h>
# include "makro2.h"
# include "makro.h"
# include "typen.h"
# include "symbols.h"
# include "y_tab.h"
# include "hilfsvar.h"
# include "code.h"        /* Codeerzeugung */
# include "scope.h"

#define FREE 0
#define RANGE 1
#define POINTER 2
#define EXAKT 1

#ifdef DEBUG
extern int no_internal;
#endif
extern ST_TYPE * typ_error, * typ_int, * typ_card, * typ_char, * typ_real,
               * typ_bool, * typ_string, * typ_bitset, * typ_nil, * typ_color;
extern Eintrag * integer_eintr, * cardinal_eintr;
extern int error_range;
extern int null_prozessoren;
extern int proc_info, proc_parall;
extern int port_variable;
extern int enum_top;
/* in calc.c */

extern ST_CONST * hole_Constkomp();

extern ST_CONST * eval_binexpr();


/* in code.c */

extern ZWCODE * check_ranges();


/* in hilfsvar.c */

extern Eintrag * get_hvar();
      
extern VARNODE * neue_hv();  /* liefert die Zieladresse fuer die Operation */

extern int hilfs_var();


/* in param.c */

extern int teste_parameter();


/* in typ.c */

extern int elementezahl();

extern int match_typen();

extern ST_TYPE * typ_berechnung();

extern int enumeration_typ();

extern int ist_cardinal();

extern int ist_stringtyp();

extern int ist_einfacher_typ();


/* in strings.c */

extern ST_CONST * erzeuge_string();

/* in pass2.c */

extern int get_Constant();

extern ST_TYPE * arrayexpr();

extern ST_TYPE * designrest();

extern ST_CONST * set_Constlist();

extern int teste_record();

extern int pruefe_record();

extern int ermittle_grenze();

extern int trage_varlist_ein();

extern int trage_var_ein();

extern int Namensliste();

extern int traceable();

extern int elsif_anweisungen();

extern int statement_lines();

extern int build_selection();

/* ******************** * /
/* Liste aller Prozeduren, die von einer Prozedur aufgerufen werden */
typedef struct Proclist {
    struct Proclist * link;
    Eintrag * wer;
    Eintrag * wo;
    int Zeile, Posit;
    int mode;
    int conf;
    int error;
    } PROCLIST;

extern PROCLIST * used_proc;
extern int info_proc;



extern VARNODE * VARi;    /* Alle Varablenknoten einer Prozedur bzw. des Hauptteils */
extern HVARS * hvarsscal, * hvarsvect; /* Kette der freien Hilfsvariablen */
extern ST_TYPE * typ_s;
extern int LINE1, LINE2, COL1, COL2;
extern int interpreter;
extern ST * dim_ST;

extern int dummy;
extern int port_anz;
extern int proz_anz, akt_proz_anz;
extern int * connect;

extern ST_TYPE * record_typ;
extern int record_scavec;

extern ST_TYPE * returntyp;
extern int retexit;            /* return oder exit erlaubt */
#define ERL_RET         1
#define ERL_EXIT        2
#define ERL_EXITLOOP    4
extern int proc_scavec;        /* Prozedurergebnis ist skalar oder vektoriell */

extern char * null_eins_string;        /* Auswahlstring bei statischer Selection */
extern int ** string_01;               /* Feld mit der Auswahl pro Dimension */
extern int sel_proz_anz;               /* Anzahl der Prozessoren nach Auswahl */
extern int select_expr;                /* Auswahl kann Zahl oder boolscher Ausdruck */
extern int Const_expr;                 /* Nur Konstanten erlaubt (fuer Const_records) */
extern int loopleft;               /* wird LOOP .. END verlassen ? */
extern int nomore;                 /* kann das naechste Statement erreicht werden ? */
extern int yywarning;              /* Anzahl der Warnungen */

extern int prozedur_zeilen;  /* Anzahl der Zeilen fuer die Prozeduren */
extern int returnstat;       /* Funktion muss ein RETURN enthalten */
extern ST * grund_ST;        /* Tabelle mit Standardfunktionen */
extern int within_selection; /* reduce innerhalb einer Selektion nur ohne Selektion */
extern ZWCODE * nach_pruefung; /* Code zur Pruefung von VAR-Parametern nach Prozurausfruf */
/*extern ZWCODE * zw;                    /* allgemeiner Zeiger */
extern WITH_COMP * wcomp;                                      

